/*
 *  Programmazione Grafica 3D - Cap. 1
 *  aggiunto da Antonio Bonifati
 *
 *  Esempio di disegno di un cerchio tramite
 *  l'algoritmo del cerchio di Bresenam
 *
 *  Questo programma  specifico per DJGPP
 *  website: http://Assembly_Page_di_Ant.freeweb.org
 */

#include <stdio.h>
#include <math.h>

     #include <dos.h>
     short video;

#define         NUM_CERCHI      30

int VideoVRAMSetupSelector (void)
 {
  static char selectorData[8] = {
    0xff, 0xf9, 0x00, 0x00,
    0x0a, 0xf3, 0x40, 0x00
  };
  int screenSelector = __dpmi_allocate_ldt_descriptors (1);
  if (__dpmi_set_descriptor (screenSelector, selectorData) < 0)
    abort ();
  return screenSelector;
 }

void Create_Selector (void)
{
  video = VideoVRAMSetupSelector();
  _farsetsel(video);
}

void PutPixel (int x, int y, char color)
 {
  _farnspokeb(x + (y*320), color);
 }

/* disegna un cerchio di centro (h,k) */
/* e raggio r col colore numero color */
 void Circle(int h, int k, int r, char color)
{
  int x,y,d;

  /* plotting punti sugli assi per il centro */
  PutPixel(h,r+k,color);
  PutPixel(r+h,k,color);
  PutPixel(-r+h,k,color);
  PutPixel(h,r+k,color);
  PutPixel(h,-r+k,color);
  PutPixel(-r+h,k,color);
  PutPixel(r+h,k,color);
  PutPixel(h,-r+k,color);

  x=0; y=r; d=3-2*r;
  while (x<y)
  {
     if (d<0)
        d=d+4*x+6;
     else
     {
        d=d+4*(x-y)+10;
        y--;
     }
     x++;

     /* plotting di 8 punti per volta poich */
     /* il cerchio ha simmetria ottupla      */
     PutPixel(x+h,y+k,color);
     PutPixel(y+h,x+k,color);
     PutPixel(-y+h,x+k,color);
     PutPixel(-x+h,y+k,color);
     PutPixel(-x+h,-y+k,color);
     PutPixel(-y+h,-x+k,color);
     PutPixel(y+h,-x+k,color);
     PutPixel(x+h,-y+k,color);
  }
}

void Set_Vga_Mode (void)
 {
  union REGS registers;

  registers.h.ah = 0x00;
  registers.h.al = 0x13;
  int386 (0x10, &registers, &registers);
 }

void Set_Text_Mode (void)
 {
  union REGS registers;

  registers.h.ah = 0x00;
  registers.h.al = 0x03;
  int386 (0x10, &registers, &registers);
 }

void Wait_Vertical_Retrace (void)
 {
  while ( (inp (0x3da) & 0x8) != 0 ) {};
  while ( (inp (0x3da) & 0x8) == 0 ) {};
 }

void main (void)
{
 int i, x,y,r,col;

 Create_Selector();
 Set_Vga_Mode ();

 srandom(85);   // numero intero a piacere
 for (i=0; i<NUM_CERCHI; i++)
 {
    r=random()%50+1;
    x=random()%(320-2*r)+r;
    y=random()%(200-2*r)+r;
    col=random()%63+1;
    Wait_Vertical_Retrace();
    Circle(x,y,r,col);
 };

 getch();

 Set_Text_Mode();
}
