/*
 *  Programmazione Grafica 3D - Cap. 1
 *  by Andrea Fasano
 *
 *  Esempio di stampa di un pixel
 *
 *  convertito per DJGPP da Antonio Bonifati
 *  website: http://Assembly_Page_di_Ant.freeweb.org
 */

#include <stdio.h>
#include <dos.h>

 #include <go32.h>      /* definisce la macro _dos_ds che ci serve */
     
void Set_Text_Mode (void)
 {
  union REGS registers;

  registers.h.ah = 0x00;                /* Servizio 0 dell' interrupt 0x10 */
  registers.h.al = 0x03;                /* Numero del nuovo modo grafico   */
  int386 (0x10, &registers, &registers);
 }

void Set_Vga_Mode (void)
 {
  union REGS registers;

  registers.h.ah = 0x00;	        /* Servizio 0 dell' interrupt 0x10 */
  registers.h.al = 0x13;		/* Numero del nuovo modo grafico   */
  int386 (0x10, &registers, &registers);
 }

void PutPixel (int x, int y, char color)
 {
  unsigned char *ScreenPointer;

  ScreenPointer = (unsigned char *) 0x0a0000;
  _farpokeb(_dos_ds, ScreenPointer+(x + (y*320)), color);
 }

void main (void)
 {
  Set_Vga_Mode ();	     /* Attiviamo la Vga */
  PutPixel (160, 100, 150);  /* Accendiamo 1 pixel nel mezzo dello schermo */
  getch();		     /* Attendiamo la pressione di un tasto */
  Set_Text_Mode ();          /* Riattiviamo la modalit testuale */
 }
