/*
 *  Programmazione Grafica 3D - Cap. 1
 *  by Andrea Fasano
 *
 *  Esempio di stampa di un pixel (quinta versione)
 *
 *  Questo metodo  il pi complesso da definire;
 *   efficiente come i precedenti, ma la protezione
 *  della memoria  completa: il processore rileva se
 *  state cercando di plottare un punto al di fuori
 *  della memoria video (senza che dovete mettere
 *  questi controlli nel vostro codice appesantendolo)
 *  e avrete un GPF (General Protection Fault) con
 *  dettagliate informazioni per risalire al punto in
 *  cui  avvenuto l'errore.
 *
 *  convertito per DJGPP da Antonio Bonifati
 *  website: http://Assembly_Page_di_Ant.freeweb.org
 */

#include <stdio.h>
#include <dos.h>

     #include <dpmi.h>          /* definisce __dpmi_segment_to_descriptor */

     short video;

int VideoVRAMSetupSelector (void)
 {
  static char selectorData[8] = {
    0xff, 0xf9, 0x00, 0x00,
    0x0a, 0xf3, 0x40, 0x00
  };
  int screenSelector = __dpmi_allocate_ldt_descriptors (1);
  if (__dpmi_set_descriptor (screenSelector, selectorData) < 0)
    abort ();
  return screenSelector;
 }

void Create_Selector (void)
{
  video = VideoVRAMSetupSelector();
  _farsetsel(video);
}

void Set_Text_Mode (void)
 {
  union REGS registers;

  registers.h.ah = 0x00;                /* Servizio 0 dell' interrupt 0x10 */
  registers.h.al = 0x03;                /* Numero del nuovo modo grafico   */
  int386 (0x10, &registers, &registers);
 }

void Set_Vga_Mode (void)
 {
  union REGS registers;

  registers.h.ah = 0x00;		/* Servizio 0 dell' interrupt 0x10 */
  registers.h.al = 0x13;		/* Numero del nuovo modo grafico   */
  int386 (0x10, &registers, &registers);
 }

void PutPixel (int x, int y, char color)
 {
  _farnspokeb(x + (y*320), color);
 }

void main (void)
 {

  Create_Selector ();

  Set_Vga_Mode ();	      /* Attiviamo la Vga */
  PutPixel (160, 100, 100);   /* Accendiamo 1 pixel nel mezzo dello schermo */
  PutPixel (319, 199, 100);   /* e un'altro in fondo a destra */
  /*PutPixel (320, 199, 100);*/   /* GPF! */
  /*PutPixel (320, 200, 100);*/   /* GPF! */
  getch();		      /* Attendiamo la pressione di un tasto */
  Set_Text_Mode ();           /* Riattiviamo la modalit testuale */
 }
