/*
 *  Programmazione Grafica 3D - Cap. 1
 *  by Andrea Fasano
 *
 *  Esempio di stampa di un pixel
 *  (versione in generale un po' pi veloce ma non c'
 *   alcun controllo sull'utilizzo della memoria; da usarsi
 *   solo per un prg. finale che si sa gi corretto. Da una
 *   prova fatta plottando a caso 200 milioni di punti 
 *   risultato che questa versione  solo di qualche % pi
 *   veloce delle precedenti)
 *
 *  Comunque, attivando le ottimizzazioni e sforzandosi di
 *  scrivere codice C quanto pi efficiente possibile,
 *  riuscite a realizzare dei programmi di demo abbastanza
 *  veloci anche senza ricorrere all'assembly.
 *
 *  convertito per DJGPP da Antonio Bonifati
 *  website: http://Assembly_Page_di_Ant.freeweb.org
 */

#include <stdio.h>
#include <dos.h>

     #include <sys/nearptr.h>

unsigned char *screen;

void Enable_Access(void)
{
     if (__djgpp_nearptr_enable())
        screen = (unsigned char *)(__djgpp_conventional_base + 0xa0000);
     else
     {
        printf("this program can't run with this DPMI server\n");
        exit(1);
     }
}

void Disable_Access(void)
{
       __djgpp_nearptr_disable();
}

void Set_Text_Mode (void)
 {
  union REGS registers;

  registers.h.ah = 0x00;                /* Servizio 0 dell' interrupt 0x10 */
  registers.h.al = 0x03;                /* Numero del nuovo modo grafico   */
  int386 (0x10, &registers, &registers);
 }

void Set_Vga_Mode (void)
 {
  union REGS registers;

  registers.h.ah = 0x00;		/* Servizio 0 dell' interrupt 0x10 */
  registers.h.al = 0x13;		/* Numero del nuovo modo grafico   */
  int386 (0x10, &registers, &registers);
 }

void PutPixel (int x, int y, char color)
 {
  screen[x+(y<<8)+(y<<6)]=color;
  //screen[x+(y*320)]=color;    /* in DJGPP non fa differenza */
                                /*   con le ottimizzazioni attivate */
 }

void main (void)
 {
  Enable_Access();

  Set_Vga_Mode ();	     /* Attiviamo la Vga */
  PutPixel (160, 100, 150);  /* Accendiamo 1 pixel nel mezzo dello schermo */
  getch();		     /* Attendiamo la pressione di un tasto */
  Set_Text_Mode ();          /* Riattiviamo la modalit testuale */

  Disable_Access();
 }
