/*
 *  Programmazione Grafica 3D - Cap. 4
 *  by Andrea Fasano
 *
 *  Questo  un esempio di scrolling SOFTWARE. Prima viene caricata l'intera
 *  immagine in un blocco di memoria di grandezza adeguata, in seguito viene
 *  copiata a pezzi di 64000 byte sullo schermo.
 *
 *  convertito per DJGPP da Antonio Bonifati
 *  website: http://Assembly_Page_di_Ant.freeweb.org
 */

#include <stdio.h>
#include "demogfx.h"

void main (void)
{
 int  offset    = 0;            /* Variabile di comodo per il conteggio */
 char direction = 1;            /* Direzione dello scrolling */

 VIRTUAL      picture;          /* La nostra immagine... */
 TYPE_PALETTE picture_pal[256]; /* ...e la sua palette   */

 Init_Graph_Lib();

 /* Attiviamo la modalit 0x13 - 320x200x256 */
 set_vga_mode ();

 /* Si alloca sufficiente memoria per l'immagine */
 picture = create_screen (320, 800);

 /* Carichiamola dal disco ed attiviamo la palette giusta */
 load_raw ("devlogo.raw", picture, picture_pal, 320*800);
 set_palette (picture_pal);

 /* Copiamo la parte superiore dell'immagine sullo schermo */
 copy_screen_to_vga (picture);

 /* Fintanto che uno non s'annoia... */
 while (!kbhit())
  {
    /* Stiamo andando in gi? */
    if (direction == 1)
      if (offset<600)
      {
        offset++;
        picture+=320;
      }
      else direction = 0;
    else
    /* Stiamo andando in s? */
      if (offset>0)
      {
        offset--;
        picture-=320;
      }
      else direction = 1;

    wait_retrace ();

    /* Copiamo l'immagine sullo schermo */
    copy_screen_to_vga (picture);

    /* Se va troppo forte, provate ad aggiungere questa istruzione */
    // delay (20);
  }

 /* DOS amore mio... */
 set_text_mode ();

 Close_Graph_Lib();
}
