/*
 *  Programmazione Grafica 3D - Cap. 4
 *  by Andrea Fasano
 *
 * Questo  un esempio di scrolling HARDWARE in modalit x. L'effetto 
 * identico a quello di esempio2.c, ma la tecnica di realizzazione 
 * differente. Notate anche la differenza di velocit di esecuzione dei due
 * programmi.
 *
 */

#include <stdio.h>
#include "demogfx.h"
#include "demo_x.h"

/*-------------------------------------------------------------------------*/
/* FUNZIONE copy_picture                                                   */
/* UTILIZZO Copia un immagine di 320x800 pixel nella memoria grafica       */
/* INPUT    scr - puntatore all'immagine                                   */
/* OUTPUT   Nessuno                                                        */
/*-------------------------------------------------------------------------*/
void copy_picture (VIRTUAL src)
{
 int i, x, y, screen_size;

 /* Grandezza della pagina */
 screen_size = screen_width * screen_height;

 /* Per ogni pagina, la attiviamo e ci scriviamo dentro un pezzo della
    immagine puntata da src */
 for (i=0; i<4; i++)
  {
   set_active_page (i);
   for (x=0; x<screen_width; x++)
    for (y=0; y<screen_height; y++)
      put_pixel_x (x, y, src[(i * screen_size) + x + y*320]);
  }
}

void main (void)
{
 int  offset    = 0;            /* Variabile di comodo per il conteggio */
 char direction = 1;            /* Direzione dello scrolling */

 VIRTUAL      picture;          /* La nostra immagine... */
 TYPE_PALETTE picture_pal[256]; /* ...e la sua palette   */

 Init_Graph_Lib();

 /* Attiviamo la modalit x 320x200 con 4 pagine di memoria */
 set_modex_320x200 ();

 /* Si alloca sufficiente memoria per l'immagine */
 picture = create_screen (320, 800);

 /* Carichiamola dal disco ed attiviamo la palette giusta */
 load_raw ("devlogo.raw", picture, picture_pal, 320*800);
 set_palette (picture_pal);

 /* Adesso la copiamo nella memoria grafica, PRIMA di entrare nel loop
    principale del programma */
 copy_picture (picture);

 /* Aspettiamo la pressione di un tasto... */
 while (!kbhit())
  {
    /* Stiamo andando in gi? */
    if (direction == 1)
      if (offset<600) offset++;
      else direction = 0;
    else
    /* Stiamo andando in s? */
      if (offset>0) offset--;
      else direction = 1;

    wait_retrace ();

    /* Guardiamo cosa c' nella memoria grafica alla riga "offset" */
     view_at (offset);

    /* Se va troppo forte, provate ad aggiungere questa istruzione */
    //delay (20);
  }

 /* Per gli amanti del nero vuoto interstellare...*/
 set_text_mode ();

 Close_Graph_Lib();
}
