/************************** vaccess.h **************************/
/* file di impostazione del tipo di accesso alla memoria video */
/***************************************************************/

#ifndef _ACCESS_
#define _ACCESS_

/* SELETTORE DEL TIPO DI ACCESSO ALLA MEMORIA VIDEO */
#define DEBUG   0     /* CAMBIARE CON 0 NELLA VERSIONE FINALE */

/****************************************************************************/
/*  INIZIALIZZAZIONE DEL MECCANISMO DI ACCESSO ALLA MEMORIA VIDEO           */
/****************************************************************************/
/* codice di inizializzazione del doppio
   meccanismo di accesso alla memoria video */
#if     DEBUG
/* primo metodo: utilizzo di un apposito selettore;
   compatibilit sicura con tutti i DPMI server;
   protezione della memoria assicurata;
   tuttavia  in genere sul 10% circa pi lento del metodo
   di accesso diretto
   questo tipo di selettore ha una dimensione
   "tonda" di 64Kb ed  fornito dallo stesso DPMI
   ancora pi semplice da utilizzare di quello
   di demogfx.h
*/

     #include <dpmi.h>
     #include <sys/farptr.h>
     #include <sys/segments.h>
     #include <sys/movedata.h>

     short video;

void Create_Selector (void)
{
  video = __dpmi_segment_to_descriptor(0xa000);
  _farsetsel(video);
}

void Init_Graph_Lib(void)
{
  Create_Selector ();
}

void Close_Graph_Lib(void)
{
}

#else
/* metodo di accesso diretto */
     #include <sys/nearptr.h>

unsigned char *vga_screen;

void Enable_Access(void)
{
     if (__djgpp_nearptr_enable())
        vga_screen = (unsigned char *)(__djgpp_conventional_base + 0xa0000);
     else
     {
        printf("video memory direct access not permetted by this DPMI server\n"
               "try to recompile with DEBUG=1\n");
        exit(1);
     }
}

void Disable_Access(void)
{
       __djgpp_nearptr_disable();
}

void Init_Graph_Lib(void)
{
   Enable_Access();
}

void Close_Graph_Lib(void)
{
   Disable_Access();
}
#endif

#endif
