/************************* vaccess2.h **************************/
/* file di impostazione del tipo di accesso alla memoria video */
/* versione di debug con due selettori ristretti               */
/***************************************************************/


/* nota: quando DEBUG  1, utilizzo due selettori separati, uno
         per la modalit x 320x200 e un'altro per quella x 320x240
         (quest'ultima ha i pixel quadrati!). Qui limitiamo
         l'uso della memoria video a 3 pagine per la 240 e 4 per la 200,
         e perci il selettore per 320x200 non va bene anche per 320x240
         perch  troppo lungo, allora serve un altro selettore.

         All'atto dell'impostazione di una delle due modalit
         (vedi funzioni
                       void set_modex_320x200 (void);
                       void set_modex_320x240 (void);
          in demo_x2.h)
         tramite la funzione _farsetsel imposto il selettore
         corretto. Provare a scrivere un programma che
         utilizza entrambe le modalit per testare questo
         codice. Provate poi a scrivere fuori schermo in
         ognuna delle modalit ed otterrete un GPF.
*/

#ifndef _ACCESS_
#define _ACCESS_

/* SELETTORE DEL TIPO DI ACCESSO ALLA MEMORIA VIDEO */
#define DEBUG   0     /* CAMBIARE CON 0 NELLA VERSIONE FINALE */

/****************************************************************************/
/*  INIZIALIZZAZIONE DEL MECCANISMO DI ACCESSO ALLA MEMORIA VIDEO           */
/****************************************************************************/
/* codice di inizializzazione del doppio
   meccanismo di accesso alla memoria video */
#if     DEBUG
/* primo metodo: utilizzo di un apposito selettore;
   compatibilit sicura con tutti i DPMI server;
   protezione della memoria assicurata;
   tuttavia  in genere sul 10% circa pi lento del metodo
   di accesso diretto */

     #include <dpmi.h>
     #include <sys/farptr.h>
     #include <sys/segments.h>
     #include <sys/movedata.h>

     short video_200, video_240;

void Create_Selectors (void)
{
  static char selectorData_200[8] = {
    0xff, 0xf9, 0x00, 0x00,             /* (320*200)/4*4-1=63999=0xf9ff */
    0x0a, 0xf3, 0x40, 0x00
  };
  static char selectorData_240[8] = {
    0xff, 0xe0, 0x00, 0x00,             /* (320*240)/4*3-1=57599=0xe0ff */
    0x0a, 0xf3, 0x40, 0x00
  };
  video_200 = __dpmi_allocate_ldt_descriptors (1);
  if (__dpmi_set_descriptor (video_200, selectorData_200) < 0)
    abort ();
  video_240 = __dpmi_allocate_ldt_descriptors (1);
  if (__dpmi_set_descriptor (video_240, selectorData_240) < 0)
    abort ();
}

void Init_Graph_Lib(void)
{
  Create_Selectors ();
}

void Close_Graph_Lib(void)
{
}

#else
/* metodo di accesso diretto */
     #include <sys/nearptr.h>

unsigned char *vga_screen;

void Enable_Access(void)
{
     if (__djgpp_nearptr_enable())
        vga_screen = (unsigned char *)(__djgpp_conventional_base + 0xa0000);
     else
     {
        printf("video memory direct access not permitted by this DPMI server\n"
               "try to recompile with DEBUG=1\n");
        exit(1);
     }
}

void Disable_Access(void)
{
       __djgpp_nearptr_disable();
}

void Init_Graph_Lib(void)
{
   Enable_Access();
}

void Close_Graph_Lib(void)
{
   Disable_Access();
}
#endif

#endif
