/*
 *  Programmazione Grafica 3D - Cap. 8
 *  by Andrea Fasano
 *
 *  Loader di immagini in formato PCX a 16 milioni di colori in 640x480
 *
 *  Questo  un esempio di utility abbastanza utile.
 *  ( analoga a display, solo che  per immagini a 24bit)
 *  Comunque questo programma non  ancora finito...
 *   in grado di visualizzare solo immagini di dimensioni 640x480
 *  dovrebbe essere possibile visualizzare immagini pi piccole,
 *  magari centrandole, come fa display.exe. A voi il compito di
 *  fare questa ed altre estensioni (tipo lo scrolling).
 *
 *  convertito per DJGPP da Antonio Bonifati
 *  website: http://Assembly_Page_di_Ant.freeweb.org
 */

#include <stdio.h>
#include <keys.h>
#include <conio.h>
#include "demogfx.h"
#include "demovbe2.h"
#include "pcx.h"

/* ritorna 1 se il nome del file non ha estensione, 0 altrimenti */
/* supporta anche estensioni pi lunghe di 3 caratteri e file    */
/* aventi solo l'estensione! (ad es. un file di nome ".prova")   */
int no_extension(char *filename)
{
   int pos=strlen(filename);

   while (pos>0)
     switch (filename[--pos])
       {
         case '.' : return 0;
         case '\\': case '/': return 1;
       }
   return 1;
}

int main (int argc, char *argv[])
{
 VIRTUAL picture;
 char file_name[128];
 char info,i;

 if (argv[1] == NULL)
  {
   printf("DISP_16M - a simple 640x480x16m colors PCX display\n\n"
         "Syntax: display [-i] filename[.pcx] ...\n"
         "        you can use wildcards like in Unix\n"
         "        -i prints pcx info (of the last file viewed) on exit\n\n");
   printf ("\nWarning: you must specify a 16 million color PCX file!");
   exit(0);
  }

 if (strcasecmp(argv[1], "-i")==0 && argc>2)
 {
    info='Y';
    i=2;
 }
 else
 {
    info='N';
    i=1;
 }

 get_vbe_info ();
 /** 640x480x32bits **/
 get_mode_info (0x112);
 set_vbe_mode (0x112);

 for (; i<argc; i++) /* per ogni file che soddisfa la wildcard */
 {
    strcpy(file_name, argv[i]);

    if (no_extension(file_name))
      strcat(file_name, ".pcx");

    if ((picture = load_pcx_truecolor (file_name))==NULL)
    {
       set_text_mode ();
       printf ("\nFile %s not found", file_name);
       abort();
    }

    /* cancelliamo lo schermo */
    blank_screen();

    /* mostriamo questa immagine */
    copy_screen_to_vbe (picture, scr_info.size);

    /* importante: liberare la memoria allocata da load_pcx_truecolor() */
    free(picture);

    if (getch()==K_Escape)
       break;
 }

 set_text_mode ();

 if (info=='Y')
    print_pcx_info(file_name);

 return(0);
}
