/*
 *  Programmazione Grafica 3D - Cap. 8
 *  by Andrea Fasano
 *
 * Esempio di utilizzo di una risoluzione VESA VBE 2.0, senza utilizzare
 * il page flipping. L'animazione presenta dunque un notevole sfarfallio.
 *
 *  convertito per DJGPP da Antonio Bonifati
 *  website: http://Assembly_Page_di_Ant.freeweb.org
 */

#include <stdio.h>
#include "demogfx.h"
#include "demovbe2.h"

void main (int argc, char *argv[])
{
 int vbe_mode, tmp, x, y;
 char color;

 /* Check */
 if (argv[1] == NULL)
  {
   printf ("\nUtilizzo: esempio1 [mode number]");
   printf ("\nmode number ::== 0  - 320x200");
   printf ("\n                 1  - 320x240");
   printf ("\n                 2  - 320x400");
   printf ("\n                 3  - 360x200");
   printf ("\n                 4  - 360x240");
   printf ("\n                 5  - 360x400");
   printf ("\n                 6  - 640x350");
   printf ("\n                 7  - 640x400");
   printf ("\n                 8  - 640x480");
   printf ("\n                 9  - 800x600");
   printf ("\n                 10 - 1024x768");
   printf ("\n                 11 - 1280x1024");
   printf ("\n                 12 - 1600x1200");
   exit (0);
  }
 else
  {
   tmp = atoi (argv[1]);
   switch (tmp)
    {
     case 0: vbe_mode = 0x153; break;
     case 1: vbe_mode = 0x154; break;
     case 2: vbe_mode = 0x155; break;
     case 3: vbe_mode = 0x156; break;
     case 4: vbe_mode = 0x157; break;
     case 5: vbe_mode = 0x158; break;
     case 6: vbe_mode = 0x11c; break;
     case 7: vbe_mode = 0x100; break;
     case 8: vbe_mode = 0x101; break;
     case 9: vbe_mode = 0x103; break;
     case 10: vbe_mode = 0x105; break;
     case 11: vbe_mode = 0x107; break;
     case 12: vbe_mode = 0x124; break;
     default: vbe_mode = 0x153;
    }
  }

 /* Attivazione risoluzione */
 get_vbe_info ();
 get_mode_info (vbe_mode);
 set_vbe_mode (vbe_mode);

 while (!kbhit ())
  {
   for (x=0; x<scr_info.x_res; x++)
    for (y=0; y<scr_info.y_res; y++)
      vbe_put_pixel (x, y, rand () % 256);
  }

 set_text_mode ();
}
